<?php
/* Autor...:  */
/* Esquema.: ALM_RequerimientoDetalle.xml */
/* Generado: 2021-08-12 07:46:43 */

/* Metodos de acceso a los campos de la tabla ALM_RequerimientoDetalle */
abstract class BaseALM_RequerimientoDetalleBN
{
    /* Campos de la tabla */
    private $i_IdRequerimientoDetalle;    // IdRequerimientoDetalle: ( no definido )
    private $i_IdRequerimiento;    // IdRequerimiento: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $f_CantidadSugerida;    // CantidadSugerida: ( no definido )
    private $f_CantidadPedida;    // CantidadPedida: ( no definido )
    private $s_IdMoneda;    // IdMoneda: ( no definido )
    private $s_IdLote;    // IdLote: ( no definido )
    private $d_FechaVencimiento;    // FechaVencimiento: ( no definido )
    private $f_StockMinimo;    // StockMinimo: ( no definido )
    private $f_StockMaximo;    // StockMaximo: ( no definido )
    private $f_PrecioUnitario;    // PrecioUnitario: ( no definido )
    private $f_PrecioUnitarioIGV;    // PrecioUnitarioIGV: ( no definido )
    private $f_PrecioSubTotal;    // PrecioSubTotal: ( no definido )
    private $f_ValorIGV;    // ValorIGV: ( no definido )
    private $f_PrecioTotalConIGV;    // PrecioTotalConIGV: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_IGVExoneradoFlag;    // IGVExoneradoFlag: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo IdRequerimientoDetalle */
    public function setIdRequerimientoDetalle( $i_IdRequerimientoDetalle )
    {
        $this->i_IdRequerimientoDetalle = $i_IdRequerimientoDetalle;
    }

    /* Obtiene el valor del campo IdRequerimientoDetalle */
    public function getIdRequerimientoDetalle()
    {
        return $this->i_IdRequerimientoDetalle;
    }

    /* Establece el valor del campo IdRequerimiento */
    public function setIdRequerimiento( $i_IdRequerimiento )
    {
        $this->i_IdRequerimiento = $i_IdRequerimiento;
    }

    /* Obtiene el valor del campo IdRequerimiento */
    public function getIdRequerimiento()
    {
        return $this->i_IdRequerimiento;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo CantidadSugerida */
    public function setCantidadSugerida( $f_CantidadSugerida )
    {
        $this->f_CantidadSugerida = $f_CantidadSugerida;
    }

    /* Obtiene el valor del campo CantidadSugerida */
    public function getCantidadSugerida()
    {
        return $this->f_CantidadSugerida;
    }

    /* Establece el valor del campo CantidadPedida */
    public function setCantidadPedida( $f_CantidadPedida )
    {
        $this->f_CantidadPedida = $f_CantidadPedida;
    }

    /* Obtiene el valor del campo CantidadPedida */
    public function getCantidadPedida()
    {
        return $this->f_CantidadPedida;
    }

    /* Establece el valor del campo IdMoneda */
    public function setIdMoneda( $s_IdMoneda )
    {
        $this->s_IdMoneda = $s_IdMoneda;
    }

    /* Obtiene el valor del campo IdMoneda */
    public function getIdMoneda()
    {
        return $this->s_IdMoneda;
    }

    /* Establece el valor del campo IdLote */
    public function setIdLote( $s_IdLote )
    {
        $this->s_IdLote = $s_IdLote;
    }

    /* Obtiene el valor del campo IdLote */
    public function getIdLote()
    {
        return $this->s_IdLote;
    }

    /* Establece el valor del campo FechaVencimiento */
    public function setFechaVencimiento( $d_FechaVencimiento )
    {
        $this->d_FechaVencimiento = $d_FechaVencimiento;
    }

    /* Obtiene el valor del campo FechaVencimiento */
    public function getFechaVencimiento()
    {
        return $this->d_FechaVencimiento;
    }

    /* Establece el valor del campo StockMinimo */
    public function setStockMinimo( $f_StockMinimo )
    {
        $this->f_StockMinimo = $f_StockMinimo;
    }

    /* Obtiene el valor del campo StockMinimo */
    public function getStockMinimo()
    {
        return $this->f_StockMinimo;
    }

    /* Establece el valor del campo StockMaximo */
    public function setStockMaximo( $f_StockMaximo )
    {
        $this->f_StockMaximo = $f_StockMaximo;
    }

    /* Obtiene el valor del campo StockMaximo */
    public function getStockMaximo()
    {
        return $this->f_StockMaximo;
    }

    /* Establece el valor del campo PrecioUnitario */
    public function setPrecioUnitario( $f_PrecioUnitario )
    {
        $this->f_PrecioUnitario = $f_PrecioUnitario;
    }

    /* Obtiene el valor del campo PrecioUnitario */
    public function getPrecioUnitario()
    {
        return $this->f_PrecioUnitario;
    }

    /* Establece el valor del campo PrecioUnitarioIGV */
    public function setPrecioUnitarioIGV( $f_PrecioUnitarioIGV )
    {
        $this->f_PrecioUnitarioIGV = $f_PrecioUnitarioIGV;
    }

    /* Obtiene el valor del campo PrecioUnitarioIGV */
    public function getPrecioUnitarioIGV()
    {
        return $this->f_PrecioUnitarioIGV;
    }

    /* Establece el valor del campo PrecioSubTotal */
    public function setPrecioSubTotal( $f_PrecioSubTotal )
    {
        $this->f_PrecioSubTotal = $f_PrecioSubTotal;
    }

    /* Obtiene el valor del campo PrecioSubTotal */
    public function getPrecioSubTotal()
    {
        return $this->f_PrecioSubTotal;
    }

    /* Establece el valor del campo ValorIGV */
    public function setValorIGV( $f_ValorIGV )
    {
        $this->f_ValorIGV = $f_ValorIGV;
    }

    /* Obtiene el valor del campo ValorIGV */
    public function getValorIGV()
    {
        return $this->f_ValorIGV;
    }

    /* Establece el valor del campo PrecioTotalConIGV */
    public function setPrecioTotalConIGV( $f_PrecioTotalConIGV )
    {
        $this->f_PrecioTotalConIGV = $f_PrecioTotalConIGV;
    }

    /* Obtiene el valor del campo PrecioTotalConIGV */
    public function getPrecioTotalConIGV()
    {
        return $this->f_PrecioTotalConIGV;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo IGVExoneradoFlag */
    public function setIGVExoneradoFlag( $s_IGVExoneradoFlag )
    {
        $this->s_IGVExoneradoFlag = $s_IGVExoneradoFlag;
    }

    /* Obtiene el valor del campo IGVExoneradoFlag */
    public function getIGVExoneradoFlag()
    {
        return $this->s_IGVExoneradoFlag;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdRequerimientoDetalle' => $this->getIdRequerimientoDetalle(),
            'IdRequerimiento' => $this->getIdRequerimiento(),
            'IdItem' => $this->getIdItem(),
            'CantidadSugerida' => $this->getCantidadSugerida(),
            'CantidadPedida' => $this->getCantidadPedida(),
            'IdMoneda' => $this->getIdMoneda(),
            'IdLote' => $this->getIdLote(),
            'FechaVencimiento' => $this->getFechaVencimiento(),
            'StockMinimo' => $this->getStockMinimo(),
            'StockMaximo' => $this->getStockMaximo(),
            'PrecioUnitario' => $this->getPrecioUnitario(),
            'PrecioUnitarioIGV' => $this->getPrecioUnitarioIGV(),
            'PrecioSubTotal' => $this->getPrecioSubTotal(),
            'ValorIGV' => $this->getValorIGV(),
            'PrecioTotalConIGV' => $this->getPrecioTotalConIGV(),
            'Estado' => $this->getEstado(),
            'IGVExoneradoFlag' => $this->getIGVExoneradoFlag(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_RequerimientoDetalleBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_RequerimientoDetalleRs )
    {
        $o_ALM_RequerimientoDetalleBN = new ALM_RequerimientoDetalleBN();
        $o_ALM_RequerimientoDetalleBN->setIdRequerimientoDetalle( ( integer ) $o_ALM_RequerimientoDetalleRs[ "IdRequerimientoDetalle" ] );
        $o_ALM_RequerimientoDetalleBN->setIdRequerimiento( ( integer ) $o_ALM_RequerimientoDetalleRs[ "IdRequerimiento" ] );
        $o_ALM_RequerimientoDetalleBN->setIdItem( $o_ALM_RequerimientoDetalleRs[ "IdItem" ] );
        $o_ALM_RequerimientoDetalleBN->setCantidadSugerida( ( float ) $o_ALM_RequerimientoDetalleRs[ "CantidadSugerida" ] );
        $o_ALM_RequerimientoDetalleBN->setCantidadPedida( ( float ) $o_ALM_RequerimientoDetalleRs[ "CantidadPedida" ] );
        $o_ALM_RequerimientoDetalleBN->setIdMoneda( $o_ALM_RequerimientoDetalleRs[ "IdMoneda" ] );
        $o_ALM_RequerimientoDetalleBN->setIdLote( $o_ALM_RequerimientoDetalleRs[ "IdLote" ] );
        $o_ALM_RequerimientoDetalleBN->setFechaVencimiento( utilTimestamp::getTimestamp( $o_ALM_RequerimientoDetalleRs[ "FechaVencimiento" ], "Y-m-d" ) );
        $o_ALM_RequerimientoDetalleBN->setStockMinimo( ( float ) $o_ALM_RequerimientoDetalleRs[ "StockMinimo" ] );
        $o_ALM_RequerimientoDetalleBN->setStockMaximo( ( float ) $o_ALM_RequerimientoDetalleRs[ "StockMaximo" ] );
        $o_ALM_RequerimientoDetalleBN->setPrecioUnitario( ( float ) $o_ALM_RequerimientoDetalleRs[ "PrecioUnitario" ] );
        $o_ALM_RequerimientoDetalleBN->setPrecioUnitarioIGV( ( float ) $o_ALM_RequerimientoDetalleRs[ "PrecioUnitarioIGV" ] );
        $o_ALM_RequerimientoDetalleBN->setPrecioSubTotal( ( float ) $o_ALM_RequerimientoDetalleRs[ "PrecioSubTotal" ] );
        $o_ALM_RequerimientoDetalleBN->setValorIGV( ( float ) $o_ALM_RequerimientoDetalleRs[ "ValorIGV" ] );
        $o_ALM_RequerimientoDetalleBN->setPrecioTotalConIGV( ( float ) $o_ALM_RequerimientoDetalleRs[ "PrecioTotalConIGV" ] );
        $o_ALM_RequerimientoDetalleBN->setEstado( $o_ALM_RequerimientoDetalleRs[ "Estado" ] );
        $o_ALM_RequerimientoDetalleBN->setIGVExoneradoFlag( $o_ALM_RequerimientoDetalleRs[ "IGVExoneradoFlag" ] );
        $o_ALM_RequerimientoDetalleBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_RequerimientoDetalleRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_RequerimientoDetalleBN->setUsuarioCreacion( $o_ALM_RequerimientoDetalleRs[ "UsuarioCreacion" ] );
        $o_ALM_RequerimientoDetalleBN->setUsuarioModificacion( $o_ALM_RequerimientoDetalleRs[ "UsuarioModificacion" ] );
        $o_ALM_RequerimientoDetalleBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_RequerimientoDetalleRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_ALM_RequerimientoDetalleBN;
    }
}
?>